/* AMX Portal
* 
* (c) Copyright 2005, KleeneX 
* This file is provided as is (no warranties). 
* 
*/
/*
//DEBUG mode switch
#define DEBUG
*/

#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <engine>

#define MAX_PORTALS	10
#define MAX_TARGETS	10
#define MAX_ALLROUNDS	10

#define ADMIN_FLAG 	ADMIN_LEVEL_A

new numPortals
new mapPortals[MAX_PORTALS]

new numTargets
new mapTargets[MAX_TARGETS]

new numAllrounds
new mapAllrounds[MAX_ALLROUNDS]

new portal_model[64] = "sprites/portal1.spr"
new target_model[64] = "sprites/portal1.spr"
new allround_model[64] = "sprites/exit1.spr"
new spr_portal, spr_target, spr_allround
new Float:frame[MAX_PORTALS]
new Float:last_frame
new Float:framerate = 4.0
//FILE SAVE
new g_mapname[50];
new g_cfgFolder[80];
new g_filename[120];
//EVAS ELIF

public plugin_precache() 
{
	spr_portal = precache_model(portal_model)
	spr_target = precache_model(target_model)
	spr_allround = precache_model(allround_model)
	precache_model("models/gate2.mdl")
	precache_sound("misc/sg1_siren.wav")
	precache_sound("misc/chevron.wav")
	precache_sound("debris/beamstart1.wav")
	precache_sound("debris/beamstart7.wav")
}

public plugin_init() 
{
	register_plugin("AMX Portal", "1.2", "KleeneX & KRoTaL")
	register_clcmd("amx_portal","create_portal",ADMIN_FLAG,":Create a Portal")
	register_clcmd("amx_ptarget","create_target",ADMIN_FLAG,":Create a Portal Target")
	register_clcmd("amx_aportal","create_allround",ADMIN_FLAG,":Create a Allround")
	
	register_clcmd("amx_r_portal","remove_portal",ADMIN_FLAG,":Remove all Portals")
	register_clcmd("amx_r_ptarget","remove_target",ADMIN_FLAG,":Remove all Targets")
	register_clcmd("amx_r_aportal","remove_allround",ADMIN_FLAG,":Remove all Allrounds")	
	
	register_clcmd("amx_save_portals","savePortals",ADMIN_FLAG,":Remove all Allrounds")
	get_mapname(g_mapname,49);
	get_configsdir(g_cfgFolder,79);
	loadPortals();
}

public draw_portal(id) 
{
	if(!is_valid_ent(id))
	return PLUGIN_HANDLED
	
	new spriteorigin[3], Float:spriteoriginF[3]
	entity_get_vector(id, EV_VEC_origin, spriteoriginF)
	FVecIVec(spriteoriginF,spriteorigin)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(17)
	write_coord(spriteorigin[0])
	write_coord(spriteorigin[1]) 
	write_coord(spriteorigin[2])
	write_short(spr_portal) 
	write_byte(30)
	write_byte(255)
	message_end()
	
	set_task(2.0, "draw_portal", id)
	
	return PLUGIN_HANDLED
}

public draw_target(id) 
{
	if(!is_valid_ent(id))
	return PLUGIN_HANDLED
	
	new spriteorigin[3], Float:spriteoriginF[3]
	entity_get_vector(id, EV_VEC_origin, spriteoriginF)
	FVecIVec(spriteoriginF,spriteorigin)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(17)
	write_coord(spriteorigin[0])
	write_coord(spriteorigin[1]) 
	write_coord(spriteorigin[2])
	write_short(spr_target) 
	write_byte(30)
	write_byte(255)
	message_end()
	
	set_task(2.0, "draw_target", id)
	
	return PLUGIN_HANDLED
}

public draw_allround(id) 
{
	if(!is_valid_ent(id))
	return PLUGIN_HANDLED
	
	new spriteorigin[3], Float:spriteoriginF[3]
	entity_get_vector(id, EV_VEC_origin, spriteoriginF)
	FVecIVec(spriteoriginF,spriteorigin)
	
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(17)
	write_coord(spriteorigin[0])
	write_coord(spriteorigin[1]) 
	write_coord(spriteorigin[2])
	write_short(spr_allround) 
	write_byte(8)
	write_byte(255)
	message_end()
	
	set_task(2.3, "draw_allround", id)
	
	return PLUGIN_HANDLED
}
public create_ent_portal(Float:pOrigin[3],Float:portal_angles[3],re){
	new portal = create_entity("info_target")
	entity_set_string(portal,EV_SZ_classname,"amx_portal")
	
	entity_set_model(portal, "models/gate2.mdl")
	entity_set_int(portal, EV_INT_flags, FL_ALWAYSTHINK)
	
	
	portal_angles[0] = 0.0 
	entity_set_vector(portal, EV_VEC_angles, portal_angles)
	
	if( ((portal_angles[1]>=45.0) && (portal_angles[1]<=135.0)) || ((portal_angles[1]>=-135.0) && (portal_angles[1]<=-45.0)) )
	{
		entity_set_size(portal, Float:{-70.0,-5.0,-70.0}, Float:{70.0,5.0,70.0} )
	}
	else
	{ 
		entity_set_size(portal, Float:{-5.0,-70.0,-70.0}, Float:{5.0,70.0,70.0} )
	}
	
	entity_set_int(portal, EV_INT_solid, 1)
	if(re){
		pOrigin[0] += 100
		pOrigin[1] += 100
	}
	entity_set_origin(portal,pOrigin)
	
	frame[numPortals] = 0.0
	
	draw_portal(portal)
	
	mapPortals[numPortals] = portal
	++numPortals
}
public create_ent_target(Float:pOrigin[3],Float:portal_angles[3]){
	new target = create_entity("info_target")
	entity_set_string(target,EV_SZ_classname,"amx_ptarget")
	
	entity_set_model(target, "models/gate2.mdl")
	entity_set_int(target, EV_INT_flags, FL_ALWAYSTHINK)
	set_rendering(target, kRenderFxNone, 0, 0, 0, kRenderTransAdd, 255)
	
	portal_angles[0] = 0.0 
	entity_set_vector(target, EV_VEC_angles, portal_angles)
	
	entity_set_origin(target,pOrigin)
	
	draw_target(target)
	
	mapTargets[numTargets] = target
	++numTargets
}
public create_ent_allround(Float:pOrigin[3],re){
	new allround = create_entity("info_target")
	entity_set_string(allround,EV_SZ_classname,"amx_aportal")
	
	entity_set_int(allround, EV_INT_flags, FL_ALWAYSTHINK)
	set_rendering(allround, kRenderFxNone, 0, 0, 0, kRenderTransAdd, 255)
	
	new Float:MinBox[3] = {-5.0, -5.0, -30.0}
	new Float:MaxBox[3] = {5.0, 5.0, 30.0}
	entity_set_size(allround, MinBox, MaxBox)
	
	entity_set_int(allround, EV_INT_solid, 1)
	if(re)
		pOrigin[1] += 80
	entity_set_origin(allround,pOrigin)
	
	draw_allround(allround)
	
	mapAllrounds[numAllrounds] = allround
	++numAllrounds
}
public create_portal(id,level,cid) {
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	if(numPortals == MAX_PORTALS) 
	{
		console_print(id, "Too many portals.")
		return PLUGIN_HANDLED
	}
	
	new Float:pOrigin[3]
	entity_get_vector(id, EV_VEC_origin, pOrigin)
	new Float:portal_angles[3] 
	entity_get_vector(id, EV_VEC_v_angle, portal_angles) 
	create_ent_portal(pOrigin, portal_angles,true);
	
	return PLUGIN_HANDLED
}

public create_target(id,level,cid) {
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	if(numTargets == MAX_TARGETS) 
	{
		console_print(id, "Too many targets.")
		return PLUGIN_HANDLED
	}
	new Float:pOrigin[3]
	entity_get_vector(id, EV_VEC_origin, pOrigin)
	new Float:portal_angles[3] 
	entity_get_vector(id, EV_VEC_v_angle, portal_angles) 
	create_ent_target(pOrigin,portal_angles);
	
	
	return PLUGIN_HANDLED
}

public create_allround(id,level,cid) {
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	if(numAllrounds == MAX_ALLROUNDS) 
	{
		console_print(id, "Too many allrounds.")
		return PLUGIN_HANDLED
	}
	new Float:pOrigin[3]
	entity_get_vector(id, EV_VEC_origin, pOrigin)
	create_ent_allround(pOrigin,true)
	
	return PLUGIN_HANDLED
}

public remove_portal(id,level,cid) {
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	for(new a = 0; a < numPortals; a++) {
		remove_entity(mapPortals[a])
	}
	numPortals = 0
	return PLUGIN_HANDLED
}

public remove_target(id,level,cid) {
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	for(new a = 0; a < numTargets; a++) {
		remove_entity(mapTargets[a])
	}
	numTargets = 0
	return PLUGIN_HANDLED
}

public remove_allround(id,level,cid) {
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	for(new a = 0; a < numAllrounds; a++) {
		remove_entity(mapAllrounds[a])
	}
	numAllrounds = 0
	return PLUGIN_HANDLED
}

public pfn_think(entid) {
	new players[32], inum
	get_players(players, inum)
	if(numTargets > 0)
	{
		for(new a = 0; a < numPortals; ++a) {
			if(is_valid_ent(mapPortals[a])) {
				new Float:origin[3]
				entity_get_vector(mapPortals[a], EV_VEC_origin, origin)
				new targetid = find_ent_in_sphere(players[0], origin, 85.0)
				while(targetid > 0)
				{
					new model[32]
					entity_get_string(targetid, EV_SZ_model, model, 31)
					if(equali(model, "models/w_",  9) || containi(model, "hostage") != -1)
					{
						new random_target
						new Float:eOrigin[3]
						random_target = mapTargets[random_num(0,numTargets - 1)]
						entity_get_vector(random_target, EV_VEC_origin, eOrigin )
						
						emit_sound(mapPortals[a], CHAN_WEAPON, "misc/sg1_siren.wav", 0.6, ATTN_STATIC, 0, PITCH_NORM)		
						
						new Float:velocity[3]
						entity_get_vector(targetid, EV_VEC_velocity, velocity)
						
						eOrigin[2] += 10
						entity_set_vector(targetid, EV_VEC_origin, eOrigin)
						
						emit_sound(random_target, CHAN_WEAPON, "misc/sg1_siren.wav", 0.6, ATTN_STATIC, 0, PITCH_NORM)
						
						if(containi(model, "hostage") != -1)
						{
							velocity[0] = 250.0
							velocity[1] = 250.0
							velocity[2] = 250.0
						}
						entity_set_vector(targetid, EV_VEC_velocity, velocity)
					}
					targetid = find_ent_in_sphere(targetid, origin, 85.0)
				}
			}
		}
	}
	if(numAllrounds > 1)
	{
		for(new a = 0; a < numAllrounds; ++a) {
			if(is_valid_ent(mapAllrounds[a])) {
				new Float:origin[3]
				entity_get_vector(mapAllrounds[a], EV_VEC_origin, origin)
				new targetid = find_ent_in_sphere(players[0], origin, 25.0)
				while(targetid > 0)
				{
					new model[32]
					entity_get_string(targetid, EV_SZ_model, model, 31)
					if(equali(model, "models/w_",  9) || containi(model, "hostage") != -1)
					{
						new random_target
						new Float:eOrigin[3]
						random_target = mapAllrounds[random_num(0,numAllrounds - 1)]
						if(random_target != mapAllrounds[a]) {
							entity_get_vector(random_target, EV_VEC_origin, eOrigin )
							
							emit_sound(mapAllrounds[a], CHAN_WEAPON, "debris/beamstart1.wav", 0.4, ATTN_NORM, 0, PITCH_NORM)
							
							new Float:velocity[3]
							entity_get_vector(targetid, EV_VEC_velocity, velocity)
							
							eOrigin[0] += 60
							eOrigin[1] += 60
							eOrigin[2] += 10
							entity_set_vector(targetid, EV_VEC_origin, eOrigin)
							
							emit_sound(random_target, CHAN_WEAPON, "debris/beamstart7.wav", 0.4, ATTN_NORM, 0, PITCH_NORM)
							
							if(containi(model, "hostage") != -1)
							{
								velocity[0] = 250.0
								velocity[1] = 250.0
								velocity[2] = 250.0
							}
							entity_set_vector(targetid, EV_VEC_velocity, velocity)
						}
					}
					targetid = find_ent_in_sphere(targetid, origin, 25.0)
				}
			}
		}
	}
}

public pfn_touch(ptr,ptd) { 
	if(ptr > 0 && ptd > 0)
	{
		new Portal[32]
		entity_get_string(ptr,EV_SZ_classname,Portal,31)
		if ( equal(Portal,"amx_portal") ) {
			if(numTargets == 0) return PLUGIN_CONTINUE
			else{
				new random_target, Origin[3]
				new Float:eOrigin[3]
				random_target = mapTargets[random_num(0,numTargets - 1)]
				entity_get_vector(random_target, EV_VEC_origin, eOrigin )
				
				emit_sound(ptr, CHAN_WEAPON, "misc/sg1_siren.wav", 0.6, ATTN_STATIC, 0, PITCH_NORM)
				
				new Float:velocity[3]
				entity_get_vector(ptd, EV_VEC_velocity, velocity)
				
				FVecIVec(Float:eOrigin,Origin)
				Origin[2] += 10
				set_user_origin(ptd,Origin)
				
				emit_sound(random_target, CHAN_WEAPON, "misc/sg1_siren.wav", 0.6, ATTN_STATIC, 0, PITCH_NORM)
				
				velocity[2] = random_float(200.0, 225.0)
				entity_set_vector(ptd, EV_VEC_velocity, velocity)
			}
		}
		if ( equal(Portal,"amx_aportal") ) {
			if(numAllrounds == 1) return PLUGIN_CONTINUE
			else{
				new random_target, Origin[3]
				new Float:eOrigin[3]
				random_target = mapAllrounds[random_num(0,numAllrounds - 1)]
				if(random_target != ptr) {
					entity_get_vector(random_target, EV_VEC_origin, eOrigin )
					FVecIVec(Float:eOrigin,Origin)
					
					emit_sound(ptr, CHAN_WEAPON, "debris/beamstart1.wav", 0.4, ATTN_NORM, 0, PITCH_NORM)
					
					Origin[0] += 40
					Origin[1] += 40
					Origin[2] += 10
					
					new Float:velocity[3]
					//entity_get_vector(ptd, EV_VEC_velocity, velocity)
					
					set_user_origin(ptd,Origin)
					
					emit_sound(random_target, CHAN_WEAPON, "debris/beamstart7.wav", 0.4, ATTN_NORM, 0, PITCH_NORM)
					
					//velocity[2] = random_float(200.0, 225.0)
					entity_set_vector(ptd, EV_VEC_velocity, velocity)
				}
			}
		}
	}
	return PLUGIN_CONTINUE
}

public server_frame()
{
	if(numPortals == 0)
	{
		return PLUGIN_CONTINUE
	}
	
	new Float:new_frame = get_gametime()
	
	if( (new_frame - last_frame) < ( 1.0 / framerate) ) 
	{
		return PLUGIN_CONTINUE 
	}
	
	last_frame = new_frame 
	
	for(new a = 0; a < numPortals; ++a) 
	{
		if(is_valid_ent(mapPortals[a])) 
		{
			entity_set_int(mapPortals[a], EV_INT_sequence, 1)
			
			frame[a] += 5.0 
			if(frame[a] >= 254.0)
			{
				frame[a] = 0.0
			}
			entity_set_float(mapPortals[a], EV_FL_frame, frame[a]) 
			if(frame[a] == 25 || frame[a] == 65 || frame[a] == 175 || frame[a] == 210 || frame[a] == 250)
			{
				emit_sound(mapPortals[a], CHAN_WEAPON, "misc/chevron.wav", 0.4, 2.6, 0, PITCH_NORM)
			}
		} 
	}
	
	return PLUGIN_CONTINUE 
}
//----------
//FILE SAVE
//----------
public savePortals(id,level,cid){
	if (!cmd_access(id,level,cid,1)) return PLUGIN_HANDLED
	new filename[120];
	new Float:origin[3],Float:angles[3];
	formatex(filename,119,"%s/portals/portals/%s",g_cfgFolder,g_mapname);
	new file=fopen(filename,"w");
	for(new i=0; i<numPortals;i++){
		entity_get_vector(mapPortals[i], EV_VEC_origin, origin);
		entity_get_vector(mapPortals[i], EV_VEC_angles, angles);
		saveBHToFile(file,i,origin,angles);
	}
	fclose(file);
	formatex(filename,119,"%s/portals/targets/%s",g_cfgFolder,g_mapname);
	file=fopen(filename,"w");
	for(new i=0; i<numTargets;i++){
		entity_get_vector(mapTargets[i], EV_VEC_origin, origin);
		entity_get_vector(mapTargets[i], EV_VEC_angles, angles);
		saveBHToFile(file,i,origin,angles);
	}
	fclose(file);
	formatex(filename,119,"%s/portals/allrounds/%s",g_cfgFolder,g_mapname);
	file=fopen(filename,"w");
	for(new i=0; i<numAllrounds;i++){
		entity_get_vector(mapAllrounds[i],EV_VEC_origin, origin);
		saveToFile(file,i,origin);
	}
	fclose(file);
	client_print(id, print_center,"Saved");
	return PLUGIN_HANDLED;
}
saveToFile(file,i,Float:origin[3]){
	new line[30];
	formatex(line,30,"[%d]^n",i);
	fputs(file,line);
	for(new i=0;i<3;i++){
		formatex(line,30,"%.0f^n",origin[i]);
		fputs(file,line);
	}
}
saveBHToFile(file,i,Float:origin[3],Float:angles[3]){
	new line[30];
	formatex(line,30,"[%d]^n",i);
	fputs(file,line);
	for(new i=0;i<3;i++){
		formatex(line,30,"%.0f^n",origin[i]);
		fputs(file,line);
	}
	for(new i=0;i<3;i++){
		formatex(line,30,"%.0f^n",angles[i]);
		fputs(file,line);
	}
}
bool:loadFromFile(i,Float:origin[3]){
	new line[10];
	new l;
	read_file(g_filename,i++, line,9,l);
	if(line[0]=='[' && line[2]==']'){
		for(new j=i;j<i+3;j++){
			read_file(g_filename,j, line,9,l);
			origin[j-i]=str_to_float(line);
		}
		return true;
	}
	return false;
	
}
bool:loadBHFromFile(i,Float:origin[3],Float:angle[3]){
	new line[10];
	new l;
	read_file(g_filename,i++, line,9,l);
	if(line[0]=='[' && line[2]==']'){
		for(new j=i;j<i+3;j++){
			read_file(g_filename,j, line,9,l);
			origin[j-i]=str_to_float(line);
		}
		i+=3;
		for(new j=i;j<i+3;j++){
			read_file(g_filename,j, line,9,l);
			angle[j-i]=str_to_float(line);
		}
		return true;
	}
	return false;
	
}
public loadPortals(){
	new i=0;
	new Float:origin[3],Float:angles[3];
	formatex(g_filename,119,"%s/portals/portals/%s",g_cfgFolder,g_mapname);
	if(file_exists(g_filename)){	
		while(loadBHFromFile(i,origin,angles)){
			create_ent_portal(origin,angles,false);
#if defined DEBUG
				log_amx("Portal: %.0f %.0f %.0f",origin[0],origin[1],origin[2]);
#endif
			i+=4;
		}
	}
	i=0
	formatex(g_filename,119,"%s/portals/targets/%s",g_cfgFolder,g_mapname);
	if(file_exists(g_filename)){	
		while(loadBHFromFile(i,origin,angles)){
			create_ent_target(origin,angles);
#if defined DEBUG
				log_amx("Target: %.0f %.0f %.0f",origin[0],origin[1],origin[2]);
#endif
			i+=4;
		}
	}
	i=0
	formatex(g_filename,119,"%s/portals/allrounds/%s",g_cfgFolder,g_mapname);
	if(file_exists(g_filename)){	
		while(loadFromFile(i,origin)){
			create_ent_allround(origin,false);
#if defined DEBUG
				log_amx("Allround: %.0f %.0f %.0f",origin[0],origin[1],origin[2]);
#endif
			i+=4;
		}
	}
}
		

